#
# FILE: DD2HTM.AWK
#
# This file translates a Data Dictionary DTD document into HTML.
#
# DATE		CHANGE
# ----		------
# 01/25/95	Added code to insert missing tags.
#
BEGIN{
#	print "<HTML>";
	ClearFlags();
}
END{
#	print "</BODY>";
#	print "</HTML>";
}
{
	if($1 == "<data-dictionary>"){
		print "<HTML>";
		print "<HEAD>";
		print "<TITLE>Data Dictionary</TITLE>";
		print "</HEAD>";
		print "<BODY>";
		next;
	}
	if($1 == "<data-dictionary>"){
		print "</BODY>";
		print "</HTML>";
	}
	if($1 == "<element>"){
		print "<HR>";
		next;
	}
	if($1 == "</element>"){
		ClearFlags();
		next;
	}
	if(/<dtd>*/){
		sub("<dtd>","");
		sub("</dtd>","");
		print "<P>";
		print "<B>DTD Module:</B>";
		print  $0 "\n";
		next;
	}
	if(/<model>*/){
		sub("<model>","",$0);
		sub("</model>","",$0);
		print "<P>";
		print "<B>Content Model:</B>";
		print "<BR>";
		print  $0 "\n";
		next;
	}
	if(/<tag>*/){
		sub("<tag>","",$0);
		sub("</tag>","",$0);
		print "<H3>" $0 "</H3>";
		next;
	}
	if(/<name>*/){
		sub("<name>","",$0);
		sub("</name>","",$0);
		print "<BR>\n<B>Name:</B> " $0 ;
		next;
	}
	if($1 == "</tag>"){
		print "</H3>";
		print "<P>";
		next;
	}
	if($1 == "<desc>"){
		print "<P><b>Description:</B>\n<P>";
		purpose = 1;
		next;
	}
	if($1 == "</desc>"){
		print "<P>";
		next;
	}
	if($1 == "<changes>"){
		print "<P>\n<b>Change Log:</B>\n<BR>\n";
		next;
	}
	if($1 == "</changes>"){
		next;
	}
	if(/<date>*/){
		sub("<date>","",$0);
		sub("</date>","",$0);
		print "<B>Date:</B>" $0 ;
		next;
	}

	if($1 == "<comment>"){
		sub("<comment>","",$0);
		print " <b>Comment:</B> " $0;
		next;
	}
	if($1 == "</comment>"){
		next;
	}

	if($1 == "<content>"){
		print "<BR>\n<b>Content:</B>\n<P>";
		next;
	}
	if($1 == "<example>"){
		examp = 1;
		print "<P>";
		print "<B>Example:</B>";
		print "<PRE>";
		FixPreEnts();
		next;
	}
	if($1 == "</example>"){
		print "\n</PRE>";
		next;
	}
	if($1 == "<attrib>"){
		print "<P>";
		print "<B>Attribute(s):</B>";
		print "<BR>";
		next;
	}
	if($1 == "</attrib>"){
		next;
	}
	if($1 == "<seealso>"){
		print "<P>";
		print "<B>See Also:</B>";
		print "<BR>";
		next;
	}

	if($1 == "</seealso>"){
		next;
	}
	print;

}
#
function FixPreEnts()
{
	gsub("\&nbsp;"," ",$0);
	gsub("\&nbp"," ",$0);
	gsub("\&lt;","<",$0);
	gsub("\&gt;",">",$0);
	gsub("\&amp","\&",$0);
}

#
function TestFlags()
{
	if(purpose == 1){
		purpose = 0;
	}
	if(entity == 1){
		entity = 0;
	}
	if(attrib == 1){
		attrib = 0;
	}
	if(examp == 1){
		examp = 0;
	}
	if(ulist == 1){
		ulist = 0;
	}
	if(tag == 1){
		tag = 0;
	}
	if(seealso == 1){
		seealso = 0;
	}
}
#
function ClearFlags()
{
	purpose = 0;
	elem = 0;
#	entity = 0;
	attrib = 0;
	examp = 0;
	tag = 0;
	seealso = 0;
	ulist = 0;
}
